﻿/*
Vampire Attack 2
Copyright (c) 2009-2010 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.vampireattack2
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;

	public class Lightning
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		private static const LAUNCH_SPEED:Number = 250;
		private static const FLIGHT_TIME:Number = 3;
		private static const DEATH_DISTANCE_SQUARED: int = 24 * 24;

// ***** VARIABLES **********************************************************

		public var _isAlive:Boolean;
		private var _timeInFlight:Number;
		
// ***** CONSTRUCTOR ********************************************************

		public function Lightning(px:Number, py:Number, ang:Number)
		{
			x = px;
			y = py;
			rotation = ang;
			_isAlive = true;
			_timeInFlight = 0;
		}


// ***** Functions - Event handlers *****************************************


// ***** Functions - General control ****************************************

		public function killIt()
		{
			_isAlive = false;
			visible = false;
		}

		/* returns true if bolt hits player */
		public function updateState(map:Map, timeDelta:Number):Boolean
		{
			if (_isAlive)
			{
				x += (Math.sin(rotation * Map.RADS_PER_DEG) * LAUNCH_SPEED * timeDelta);
				y += (-Math.cos(rotation * Map.RADS_PER_DEG) * LAUNCH_SPEED * timeDelta);
				_timeInFlight += timeDelta;
				// distance from player
				var deltaX = map._player.x - x;
				var deltaY = map._player.y - y;
				var distanceSquared:Number = deltaX * deltaX + deltaY * deltaY;
				if (distanceSquared < DEATH_DISTANCE_SQUARED) return true;
				// end of lifespan or running into a wall check
				if ( (_timeInFlight >= FLIGHT_TIME) ||
							(map.getTile((x /Map.TILE_SIZE)&63, (y /Map.TILE_SIZE)&63) > 23) )
				{
					_isAlive = false;
					_visible = false;
				}
			}
			return false;
		}
				
		public function isAlive():Boolean
		{
			return _isAlive;
		}

	} // end class
} // end package

