﻿/*
Vampire Attack 2
Copyright (c) 2009-2010 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.vampireattack2
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;

	public class Stake
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		private static const DISTANCE_FROM_PLAYER:Number = 25;
		private static const LAUNCH_SPEED:Number = 250;
		private static const FLIGHT_TIME:Number = 3;

// ***** VARIABLES **********************************************************

		public var _isAlive:Boolean;
		private var _launchedFlag:Boolean;
		private var _timeInFlight:Number;
		
// ***** CONSTRUCTOR ********************************************************

		public function Stake()
		{
			_isAlive = true;
			_launchedFlag = false;
			_timeInFlight = 0;
		}


// ***** Functions - Event handlers *****************************************


// ***** Functions - General control ****************************************
		
		public function updateState(map:Map, timeDelta:Number):void
		{
			if (_launchedFlag == true)
			{
				x += (Math.sin(rotation * Map.RADS_PER_DEG) * LAUNCH_SPEED * timeDelta);
				y += (-Math.cos(rotation * Map.RADS_PER_DEG) * LAUNCH_SPEED * timeDelta);
				_timeInFlight += timeDelta;
				if ( (_timeInFlight >= FLIGHT_TIME) ||
							(map.getTile((x /Map.TILE_SIZE)&63, (y /Map.TILE_SIZE)&63) > 23) )
				{
					_isAlive = false;
					_visible = false;
				}
			}
			else
			{
				x = Math.sin(map._player.rotation * Map.RADS_PER_DEG) * DISTANCE_FROM_PLAYER + map._player.x;
				y = -Math.cos(map._player.rotation * Map.RADS_PER_DEG) * DISTANCE_FROM_PLAYER + map._player.y;
				rotation = map._player.rotation;
			}
		}
		
		public function launch():void
		{
			_launchedFlag = true;
		}
		
		public function isLaunched():Boolean
		{
			return _launchedFlag;
		}
		
		public function isAlive():Boolean
		{
			return _isAlive;
		}

	} // end class
} // end package

